function [U]=HSTdnTouch_MCA(param)
S=[75 100 125];
V=0.114;
K=100;
T=1;
r=0;
kappa=2.58;
eta=0.043;
sigma=1;
rho=-0.36;
L=50;
H=150;
N=2000;
Ntraj=1e4;
tic
[tmpDNT(1,:),e0]=Sim_DNT(T,N,Ntraj,1,r,[V kappa eta sigma rho],log(L./S),log(H./S));
dt=toc;
nrep=ceil((2*max(e0)/param)^2);
if nrep>1
 disp(['Estimated running time: '  num2str(dt*(nrep-1)) ' s.']);
end 
for i=2:nrep
    %i
 [tmpDNT(i,:)]=Sim_DNT(T,N,Ntraj,1,r,[V kappa eta sigma rho],log(L./S),log(H./S));
end
U=mean(tmpDNT,1);


function [DNT,sdev]=Sim_DNT(T,N,Ntraj,S0,r,parameter,L,H)

                    % T length of time interval 
                    % N nbr of sample points
                    % Ntraj number of trajectories
v0=parameter(1);    % Initial volatilitet
k=parameter(2);     % volatility mean reversion
th=parameter(3);    % volatility mean
sv=parameter(4);    % volatility diffusion
rho=parameter(5);   % diffusion correlation

dt=T/N;
d=4*th*k/sv^2;
lambda=4*k*exp(-k*dt)/(sv^2*(1-exp(-k*dt)));
konstant=sv^2*(1-exp(-k*dt))/(4*k);
I1=logical(ones(Ntraj,3));
I2=I1;
V=zeros(Ntraj,1);
X1=V;
X2=V;
IV=V;
V(:,1)=v0;
X1(:,1)=log(S0);
X2(:,1)=log(S0);
L=repmat(L,Ntraj,1);
H=repmat(H,Ntraj,1);
XX1=repmat(X1,1,3);
XX2=repmat(X2,1,3);
DH1=(H-XX1);
DH2=(H-XX2);
DL1=(XX1-L);
DL2=(XX2-L);
for i=2:(N+1)
    Vnew=konstant*ncx2rnd(d,lambda*V);
    IVds=dt*(V+Vnew)/2;
    IsqrtVdW=(Vnew-V-k*th*dt+k*IVds)/sv;
    G=randn(Ntraj,1);
    X1=X1+r*dt-0.5*IVds+rho*IsqrtVdW+sqrt((1-rho^2)*IVds).*G;
    X2=X2+r*dt-0.5*IVds+rho*IsqrtVdW-sqrt((1-rho^2)*IVds).*G;
    V=Vnew;
    XX1=repmat(X1,1,3);
    XX2=repmat(X2,1,3);
    a=repmat(IVds,1,3);
    U1=repmat(rand(Ntraj,1),1,3);
    U2=repmat(rand(Ntraj,1),1,3);
    P11=exp(-DH1.*(H-XX1)./a);
    P12=exp(-DH2.*(H-XX2)./a);
    P21=exp(-DL1.*(XX1-L)./a);
    P22=exp(-DL2.*(XX2-L)./a);
    I1=I1&(XX1>L)&(XX1<H)&(P11<U1)&(P21<U2);
    I2=I2&(XX2>L)&(XX2<H)&(P12<U1)&(P22<U2);
    DH1=(H-XX1);
    DH2=(H-XX2);
    DL1=(XX1-L);
    DL2=(XX2-L);
end   
DNT=mean((I1+I2)/2);
sdev=std((I1+I2)/2)/sqrt(Ntraj);

