function [U]=HSTeuCall_MCA(param)
T = 1; 
kappa= 2.58; 
eta=0.043; 
sig=1; 
rho=-0.36;
S0 = [75 100 125];
V0=0.114;
r=0;
K=100;
N=500;
Ntraj=1e4;
fun=@Sim_Heston;
tic
[tmp(1,:),e0]=fun(T,N,Ntraj,S0,K,r,[V0 kappa eta sig rho]);
dt=toc;
nrep=ceil((2*max(e0)/param)^2);
if nrep>1
 disp(['Estimated running time: '  num2str(dt*(nrep-1)) ' s.']);   end 
for i=2:nrep
    %i
 [tmp(i,:)]=fun(T,N,Ntraj,S0,K,r,[V0 kappa eta sig rho]);
end
U=mean(tmp,1);



function [U,sdev]=Sim_Heston(T,N,Ntraj,S0,K,r,parameter)

                    % T length of time interval 
                    % N nbr of sample points
                    % Ntraj number of trajectories
v0=parameter(1);    % Initial volatilitet
k=parameter(2);     % volatility mean reversion
th=parameter(3);    % volatility mean
sv=parameter(4);    % volatility diffusion
rho=parameter(5);   % diffusion correlation

dt=T/N;
d=4*th*k/sv^2;
lambda=4*k*exp(-k*dt)/(sv^2*(1-exp(-k*dt)));
konstant=sv^2*(1-exp(-k*dt))/(4*k);
V=zeros(Ntraj,1);
X1=V;
X2=V;
IV=V;
V(:,1)=v0;
X1(:,1)=0;
X2(:,1)=0;
for i=2:(N+1)
    Vnew=konstant*ncx2rnd(d,lambda*V);
    IVds=dt*(V+Vnew)/2;
    IsqrtVdW=(Vnew-V-k*th*dt+k*IVds)/sv;
    G=randn(Ntraj,1);
    X1=X1+r*dt-0.5*IVds+rho*IsqrtVdW+sqrt((1-rho^2)*IVds).*G;
    X2=X2+r*dt-0.5*IVds+rho*IsqrtVdW-sqrt((1-rho^2)*IVds).*G;
    V=Vnew;
end   
S1=exp(X1)*S0;
S2=exp(X2)*S0;
SS0=repmat(S0,Ntraj,1);
P0=exp(-r*T);
a=sum(P0/2*(max(S1-K,0)+max(S2-K,0)).*(P0*(S1+S2)/2-SS0))./(S0.^2.*sum((P0*(exp(X1)+exp(X2))/2-1).^2));
U=P0*mean((max(S1-K,0)+max(S2-K,0))/2-(P0*(S1+S2)/2-SS0).*repmat(a,Ntraj,1));
sdev=P0*std((max(S1-K,0)+max(S2-K,0))/2-(P0*(S1+S2)/2-SS0).*repmat(a,Ntraj,1))/sqrt(Ntraj);